/*!
 * © 2017 David Vines
 *
 * Creative Commons License
 *
 * This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
 */
/* exported classof, type, cloneNodeWithNewIds */

function classof(o) {
    return Object.prototype.toString.call(o).slice(8,-1);
}

function type(o) {
    if (o === null) {
        return "null";
    }
    if (o !== o) {
        return "NaN";
    }
    var t = typeof o;
    if (t !== "Object") {
        return t;
    }
    var c = classof(o);
    if (c !== "Object") {
        return c;
    }
    if (o.constructor &&
        typeof o.constructor === "function") {
        var n = o.constructor.getName();
        if (n) {
            return n;
        }
    }
    return "Object";
}

function updateNodeWithNewIds(node, oldidpattern, newidinsert) {
    if (node instanceof Element) {
        var match = node.id.match(oldidpattern);
        if (match !== null) {
            node.id = node.id.replace(oldidpattern,newidinsert);
        }
        if (node.hasChildNodes()) {
            var children = node.childNodes;
            for(var i=0; i<children.length; i++) {
                updateNodeWithNewIds(children[i],oldidpattern,newidinsert);
            }
        }
    }
}

function cloneNodeWithNewIds(oldnode, oldidpattern, newidinsert) {
    var clone = oldnode.cloneNode(true);
    updateNodeWithNewIds(clone,oldidpattern,newidinsert);
    return clone;
}